﻿Option Strict Off
Option Explicit On

Module Module1
    '====================================
    'INTERFACE DEKlarationen für FTDI DLL
    '====================================
    
    Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" (ByVal arg1 As Integer, ByVal arg2 As String, ByVal dwFlags As Integer) As Integer

    Public Declare Function FT_GetNumDevices Lib "FTD2XX.DLL" Alias "FT_ListDevices" (ByRef arg1 As Integer, ByVal arg2 As String, ByVal dwFlags As Integer) As Integer

    Public Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal intDeviceNumber As Short, ByRef lngHandle As Integer) As Integer

    Public Declare Function FT_OpenEx Lib "FTD2XX.DLL" (ByVal arg1 As String, ByVal arg2 As Integer, ByRef lngHandle As Integer) As Integer

    Public Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lpszBuffer As String, ByVal lngBufferSize As Integer, ByRef lngBytesReturned As Integer) As Integer

    Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lpszBuffer As String, ByVal lngBufferSize As Integer, ByRef lngBytesWritten As Integer) As Integer

    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
    Public Declare Function FT_WriteByte Lib "FTD2XX.DLL" Alias "FT_Write" (ByVal lngHandle As Integer, ByRef lpszBuffer As Integer, ByVal lngBufferSize As Integer, ByRef lngBytesWritten As Integer) As Integer

    Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngBaudRate As Integer) As Integer

    Public Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal byWordLength As Byte, ByVal byStopBits As Byte, ByVal byParity As Byte) As Integer

    Public Declare Function FT_SetFlowControl Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal intFlowControl As Short, ByVal byXonChar As Byte, ByVal byXoffChar As Byte) As Integer

    Public Declare Function FT_SetDtr Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_ClrDtr Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_SetRts Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_ClrRts Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_GetModemStatus Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lngModemStatus As Integer) As Integer

    Public Declare Function FT_SetChars Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal byEventChar As Byte, ByVal byEventCharEnabled As Byte, ByVal byErrorChar As Byte, ByVal byErrorCharEnabled As Byte) As Integer

    Public Declare Function FT_Purge Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngMask As Integer) As Integer

    Public Declare Function FT_SetTimeouts Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngReadTimeout As Integer, ByVal lngWriteTimeout As Integer) As Integer

    Public Declare Function FT_GetQueueStatus Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lngRxBytes As Integer) As Integer

    Public Declare Function FT_SetBreakOn Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_SetBreakOff Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_GetStatus Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lngRxBytes As Integer, ByRef lngTxBytes As Integer, ByRef lngEventsDWord As Integer) As Integer

    Public Declare Function FT_SetEventNotification Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal dwEventMask As Integer, ByVal pVoid As Integer) As Integer

    Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
    Public Declare Function FT_GetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef intData As Integer) As Integer

    Public Declare Function FT_SetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal intMask As Byte, ByVal intMode As Byte) As Integer

    Public Declare Function FT_SetLatencyTimer Lib "FTD2XX.DLL" (ByVal Handle As Integer, ByVal pucTimer As Byte) As Integer

    Public Declare Function FT_GetLatencyTimer Lib "FTD2XX.DLL" (ByVal Handle As Integer, ByRef ucTimer As Integer) As Integer

    ' Return codes
    Public Const FT_OK As Short = 0
    Public Const FT_INVALID_HANDLE As Short = 1
    Public Const FT_DEVICE_NOT_FOUND As Short = 2
    Public Const FT_DEVICE_NOT_OPENED As Short = 3
    Public Const FT_IO_ERROR As Short = 4
    Public Const FT_INSUFFICIENT_RESOURCES As Short = 5
    Public Const FT_INVALID_PARAMETER As Short = 6
    Public Const FT_INVALID_BAUD_RATE As Short = 7
    Public Const FT_DEVICE_NOT_OPENED_FOR_ERASE As Short = 8
    Public Const FT_DEVICE_NOT_OPENED_FOR_WRITE As Short = 9
    Public Const FT_FAILED_TO_WRITE_DEVICE As Short = 10
    Public Const FT_EEPROM_READ_FAILED As Short = 11
    Public Const FT_EEPROM_WRITE_FAILED As Short = 12
    Public Const FT_EEPROM_ERASE_FAILED As Short = 13
    Public Const FT_EEPROM_NOT_PRESENT As Short = 14
    Public Const FT_EEPROM_NOT_PROGRAMMED As Short = 15
    Public Const FT_INVALID_ARGS As Short = 16
    Public Const FT_NOT_SUPPORTED As Short = 17
    Public Const FT_OTHER_ERROR As Short = 18

    ' Flags für FT_OpenEx
    Public Const FT_OPEN_BY_SERIAL_NUMBER As Short = 1
    Public Const FT_OPEN_BY_DESCRIPTION As Short = 2

    ' Flags für FT_ListDevices
    Public Const FT_LIST_BY_NUMBER_ONLY As Integer = &H80000000
    Public Const FT_LIST_BY_INDEX As Integer = &H40000000
    Public Const FT_LIST_ALL As Integer = &H20000000

    ' IO buffer
    Public Const FT_In_Buffer_Size As Short = 1024
    Public Const FT_Out_Buffer_Size As Short = 1024

    'Public FT_In_Buffer As New VB6.FixedLengthString(FT_In_Buffer_Size)
    'Public FT_Out_Buffer As New VB6.FixedLengthString(FT_Out_Buffer_Size)
    Public FT_IO_Status As Integer
    Public FT_Result As Integer
    Public FT_Device_Count As Integer
    'Public FT_Device_String_Buffer As New VB6.FixedLengthString(50)
    Public FT_Device_String As String

    Public lngHandle As Integer

    Public FT_HANDLE As Integer



    Public Sub FT_Error_Report(ByRef ErrStr As String, ByRef PortStatus As Integer)
        ' Fehlermeldungen
        'UPGRADE_NOTE: Str was upgraded to Str_Renamed. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
        Dim Str_Renamed As String

        Select Case PortStatus
            Case FT_INVALID_HANDLE
                Str_Renamed = ErrStr & " - Invalid Handle"
            Case FT_DEVICE_NOT_FOUND
                Str_Renamed = ErrStr & " - Device Not Found"
            Case FT_DEVICE_NOT_OPENED
                Str_Renamed = ErrStr & " - Device Not Opened"
            Case FT_IO_ERROR
                Str_Renamed = ErrStr & " - General IO Error"
            Case FT_INSUFFICIENT_RESOURCES
                Str_Renamed = ErrStr & " - Insufficient Resources"
            Case FT_INVALID_PARAMETER
                Str_Renamed = ErrStr & " - Invalid Parameter"
            Case FT_INVALID_BAUD_RATE
                Str_Renamed = ErrStr & " - Invalid Baud Rate"
            Case FT_DEVICE_NOT_OPENED_FOR_ERASE
                Str_Renamed = ErrStr & " - Device not opened for Erase"
            Case FT_DEVICE_NOT_OPENED_FOR_WRITE
                Str_Renamed = ErrStr & " - Device not opened for Write"
            Case FT_FAILED_TO_WRITE_DEVICE
                Str_Renamed = ErrStr & " - Failed to write Device"
            Case FT_EEPROM_READ_FAILED
                Str_Renamed = ErrStr & " - EEPROM read failed"
            Case FT_EEPROM_WRITE_FAILED
                Str_Renamed = ErrStr & " - EEPROM write failed"
            Case FT_EEPROM_ERASE_FAILED
                Str_Renamed = ErrStr & " - EEPROM erase failed"
            Case FT_EEPROM_NOT_PRESENT
                Str_Renamed = ErrStr & " - EEPROM not present"
            Case FT_EEPROM_NOT_PROGRAMMED
                Str_Renamed = ErrStr & " - EEPROM not programmed"
            Case FT_INVALID_ARGS
                Str_Renamed = ErrStr & " - Invalid Arguments"
            Case FT_NOT_SUPPORTED
                Str_Renamed = ErrStr & " - not supported"
            Case FT_OTHER_ERROR
                Str_Renamed = ErrStr & " - other error"
        End Select

    End Sub
End Module
